AllieInfantryIncome = function()
	if not AlliePeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomInfUnit = Utils.Random(AllieInfUnit)
		if RandomInfUnit == "e1" then AllieInfDelayTimemax  = 5
		elseif RandomInfUnit == "e3" then AllieInfDelayTimemax  = 6
		elseif RandomInfUnit == "medi" then AllieInfDelayTimemax  = 4
		elseif RandomInfUnit == "mech" then AllieInfDelayTimemax  = 6 end
		if not tentKilled0 then
			EnemyUnit0 = Actor.Create(RandomInfUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not tentKilled1 then
			EnemyUnit1 = Actor.Create(RandomInfUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not tentKilled2 then
			EnemyUnit2 = Actor.Create(RandomInfUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not tentKilled3 then
			EnemyUnit3 = Actor.Create(RandomInfUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not tentKilled4 then
			EnemyUnit4 = Actor.Create(RandomInfUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AllieInfDelayTimemin + AllieInfDelay, AllieInfDelayTimemax + AllieInfDelay)), function()
			AllieInfantryIncome()
		end)
	end)
end

SovietInfantryIncome = function()
	if not SovietPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomInfUnit2 = Utils.Random(SovietInfUnit)
		if RandomInfUnit2 == "e1" then SovietInfDelayTimemax = 5
		elseif RandomInfUnit2 == "e2" then SovietInfDelayTimemax = 4
		elseif RandomInfUnit2 == "e3" then SovietInfDelayTimemax = 6
		elseif RandomInfUnit2 == "e4" then SovietInfDelayTimemax = 9
		elseif RandomInfUnit2 == "shok" then SovietInfDelayTimemax = 10
		elseif RandomInfUnit2 == "dog" then SovietInfDelayTimemax = 4
		end
		if not barrKilled0 then
			EnemyUnit0 = Actor.Create(RandomInfUnit2, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not barrKilled1 then
			EnemyUnit1 = Actor.Create(RandomInfUnit2, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not barrKilled2 then
			EnemyUnit2 = Actor.Create(RandomInfUnit2, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not barrKilled3 then
			EnemyUnit3 = Actor.Create(RandomInfUnit2, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not barrKilled4 then
			EnemyUnit4 = Actor.Create(RandomInfUnit2, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(SovietInfDelayTimemin + SovietInfDelay, SovietInfDelayTimemax + SovietInfDelay)), function()
			SovietInfantryIncome()
		end)
	end)
end

GdiInfantryIncome = function()
	if not GdiPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomInfUnit3 = Utils.Random(GdiInfUnit)
		if RandomInfUnit3 == "e1cnc" then GdiInfDelayTimemax = 5
		elseif RandomInfUnit3 == "e2cnc" then GdiInfDelayTimemax = 4
		elseif RandomInfUnit3 == "e3cnc" then GdiInfDelayTimemax = 6
		elseif RandomInfUnit3 == "gnrl" then GdiInfDelayTimemax = 10 end
		if not pyleKilled0 then
			EnemyUnit0 = Actor.Create(RandomInfUnit3, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not pyleKilled1 then
			EnemyUnit1 = Actor.Create(RandomInfUnit3, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not pyleKilled2 then
			EnemyUnit2 = Actor.Create(RandomInfUnit3, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not pyleKilled3 then
			EnemyUnit3 = Actor.Create(RandomInfUnit3, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not pyleKilled4 then
			EnemyUnit4 = Actor.Create(RandomInfUnit3, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(GdiInfDelayTimemin + GdiInfDelay, GdiInfDelayTimemax + GdiInfDelay)), function()
			GdiInfantryIncome()
		end)
	end)
end






NodInfantryIncome = function()
	if not NodPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomInfUnit4 = Utils.Random(NodInfUnit)
		if RandomInfUnit4 == "e1cnc" then NodInfDelayTimemax = 5
		elseif RandomInfUnit4 == "e3cnc" then NodInfDelayTimemax = 6
		elseif RandomInfUnit4 == "e4cnc" then NodInfDelayTimemax = 7
		elseif RandomInfUnit4 == "e5cnc" then NodInfDelayTimemax = 8 end
		if not handKilled0 then
			EnemyUnit0 = Actor.Create(RandomInfUnit4, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not handKilled1 then
			EnemyUnit1 = Actor.Create(RandomInfUnit4, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not handKilled2 then
			EnemyUnit2 = Actor.Create(RandomInfUnit4, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not handKilled3 then
			EnemyUnit3 = Actor.Create(RandomInfUnit4, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not handKilled4 then
			EnemyUnit4 = Actor.Create(RandomInfUnit4, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(NodInfDelayTimemin + NodInfDelay, NodInfDelayTimemax + NodInfDelay)), function()
			NodInfantryIncome()
		end)
	end)
end

AllieVehicleIncome = function()
	if not AlliePeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomVehUnit = Utils.Random(AllieVehUnit)
		if RandomVehUnit == "1tnk" then AllieVehDelayTimemax = 13
		elseif RandomVehUnit == "jeep" then AllieVehDelayTimemax = 8 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomVehUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomVehUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomVehUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomVehUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomVehUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AllieVehDelayTimemin + AllieVehDelay, AllieVehDelayTimemax + AllieVehDelay)), function()
			AllieVehicleIncome()
		end)
	end)
end
SovietVehicleIncome = function()
	if not SovietPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomVehUnit2 = Utils.Random(SovietVehUnit)
		if RandomVehUnit2 == "apc" then SovietVehDelayTimemax = 12
		elseif RandomVehUnit2 == "ftrk" then SovietVehDelayTimemax = 10 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomVehUnit2, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomVehUnit2, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomVehUnit2, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomVehUnit2, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomVehUnit2, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(SovietVehDelayTimemin + SovietVehDelay, SovietVehDelayTimemax + SovietVehDelay)), function()
			SovietVehicleIncome()
		end)
	end)
end

GdiVehicleIncome = function()
	if not GdiPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomVehUnit3 = Utils.Random(GdiVehUnit)
		if RandomVehUnit3 == "apccnc" then GdiVehDelayTimemax = 13
		elseif RandomVehUnit3 == "humv" then GdiVehDelayTimemax = 8 end
		if not weapcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomVehUnit3, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomVehUnit3, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomVehUnit3, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomVehUnit3, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomVehUnit3, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(GdiVehDelayTimemin + GdiVehDelay, GdiVehDelayTimemax + GdiVehDelay)), function()
			GdiVehicleIncome()
		end)
	end)
end

NodVehicleIncome = function()
	if not NodPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomVehUnit4 = Utils.Random(NodVehUnit)
		if RandomVehUnit4 == "bggy" then NodVehDelayTimemax = 8
		elseif RandomVehUnit4 == "bike" then NodVehDelayTimemax = 13
		elseif RandomVehUnit4 == "ftnkcnc" then NodVehDelayTimemax = 10
		elseif RandomVehUnit4 == "mlrs" then NodVehDelayTimemax = 8 end
		if not afldcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomVehUnit4, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not afldcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomVehUnit4, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not afldcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomVehUnit4, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not afldcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomVehUnit4, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not afldcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomVehUnit4, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(NodVehDelayTimemin + NodVehDelay, NodVehDelayTimemax + NodVehDelay)), function()
			NodVehicleIncome()
		end)
	end)
end

AllieTnkIncome = function()
	if not AlliePeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomTnkUnit = Utils.Random(AllieTnkUnit)
		if RandomTnkUnit == "2tnk" then AllieTnkDelayTimemax = 16
		elseif RandomTnkUnit == "ctnk" then AllieTnkDelayTimemax = 14 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomTnkUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomTnkUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomTnkUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomTnkUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomTnkUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AllieTnkDelayTimemin + AllieTnkDelay, AllieTnkDelayTimemax + AllieTnkDelay)), function()
			AllieTnkIncome()
		end)
	end)
end

SovietTnkIncome = function()
	if not SovietPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomTnkUnit1 = Utils.Random(SovietTnkUnit)
		if RandomTnkUnit1 == "3tnk" then SovietTnkDelayTimemax = 20
		elseif RandomTnkUnit1 == "4tnk" then SovietTnkDelayTimemax = 26
		elseif RandomTnkUnit1 == "ttnk" then SovietTnkDelayTimemax = 15 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomTnkUnit1, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomTnkUnit1, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomTnkUnit1, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomTnkUnit1, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomTnkUnit1, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(SovietTnkDelayTimemin + SovietTnkDelay, SovietTnkDelayTimemax + SovietTnkDelay)), function()
			SovietTnkIncome()
		end)
	end)
end

GdiTnkIncome = function()
	if not GdiPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomTnkUnit2 = Utils.Random(GdiTnkUnit)
		if RandomTnkUnit2 == "mtnk" then GdiTnkDelayTimemax = 16
		elseif RandomTnkUnit2 == "htnk" then GdiTnkDelayTimemax = 27 end
		if not weapcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomTnkUnit2, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomTnkUnit2, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomTnkUnit2, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomTnkUnit2, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomTnkUnit2, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(GdiTnkDelayTimemin + GdiTnkDelay, GdiTnkDelayTimemax + GdiTnkDelay)), function()
			GdiTnkIncome()
		end)
	end)
end

NodTnkIncome = function()
	if not NodPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomTnkUnit3 = Utils.Random(NodTnkUnit)
		if RandomTnkUnit3 == "ltnk" then NodTnkDelayTimemax = 14
		elseif RandomTnkUnit3 == "stnkcnc" then NodTnkDelayTimemax = 16 end
		if not afldcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomTnkUnit3, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not afldcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomTnkUnit3, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not afldcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomTnkUnit3, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not afldcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomTnkUnit3, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not afldcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomTnkUnit3, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(NodTnkDelayTimemin + NodTnkDelay, NodTnkDelayTimemax + NodTnkDelay)), function()
			NodTnkIncome()
		end)
	end)
end

AllieArtyIncome = function()
	if not AlliePeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomArtyUnit = Utils.Random(AllieArtyUnit)
		if RandomArtyUnit == "arty" then AllieArtyDelayTimemax = 20 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomArtyUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomArtyUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomArtyUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomArtyUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomArtyUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AllieArtyDelayTimemin + AllieArtyDelay, AllieArtyDelayTimemax + AllieArtyDelay)), function()
			AllieArtyIncome()
		end)
	end)
end
SovietArtyIncome = function()
	if not SovietPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomArtyUnit1 = Utils.Random(SovietArtyUnit)
		if RandomArtyUnit1 == "v2rl" then AllieArtyDelayTimemax = 20 end
		if not weapKilled0 then
			EnemyUnit0 = Actor.Create(RandomArtyUnit1, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapKilled1 then
			EnemyUnit1 = Actor.Create(RandomArtyUnit1, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapKilled2 then
			EnemyUnit2 = Actor.Create(RandomArtyUnit1, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapKilled3 then
			EnemyUnit3 = Actor.Create(RandomArtyUnit1, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapKilled4 then
			EnemyUnit4 = Actor.Create(RandomArtyUnit1, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(SovietArtyDelayTimemin + SovietArtyDelay, SovietArtyDelayTimemax + SovietArtyDelay)), function()
			SovietArtyIncome()
		end)
	end)
end
GdiArtyIncome = function()
	if not GdiPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomArtyUnit2 = Utils.Random(GdiArtyUnit)
		if RandomArtyUnit2 == "msam" then GdiArtyDelayTimemax = 20 end
		if not weapcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomArtyUnit2, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not weapcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomArtyUnit2, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not weapcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomArtyUnit2, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not weapcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomArtyUnit2, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not weapcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomArtyUnit2, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(GdiArtyDelayTimemin + GdiArtyDelay, GdiArtyDelayTimemax + GdiArtyDelay)), function()
			GdiArtyIncome()
		end)
	end)
end
NodArtyIncome = function()
	if not NodPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomArtyUnit3 = Utils.Random(NodArtyUnit)
		if RandomArtyUnit3 == "artycnc" then NodArtyDelayTimemax = 20 end
		if not afldcncKilled0 then
			EnemyUnit0 = Actor.Create(RandomArtyUnit3, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not afldcncKilled1 then
			EnemyUnit1 = Actor.Create(RandomArtyUnit3, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not afldcncKilled2 then
			EnemyUnit2 = Actor.Create(RandomArtyUnit3, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not afldcncKilled3 then
			EnemyUnit3 = Actor.Create(RandomArtyUnit3, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not afldcncKilled4 then
			EnemyUnit4 = Actor.Create(RandomArtyUnit3, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(NodArtyDelayTimemin + NodArtyDelay, NodArtyDelayTimemax + NodArtyDelay)), function()
			NodArtyIncome()
		end)
	end)
end
AllieHeliIncome = function()
	if not AlliePeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomHeliUnit = Utils.Random(AllieHeliUnit)
		if RandomHeliUnit == "mh60" then AllieHeliDelayTimemax = 18
		elseif RandomHeliUnit == "heli" then AllieHeliDelayTimemax = 25 end
		if not hpadKilled0 then
			EnemyUnit0 = Actor.Create(RandomHeliUnit, true, { Location = CPos.New(151,11) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not hpadKilled1 then
			EnemyUnit1 = Actor.Create(RandomHeliUnit, true, { Location = CPos.New(151,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not hpadKilled2 then
			EnemyUnit2 = Actor.Create(RandomHeliUnit, true, { Location = CPos.New(151,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not hpadKilled3 then
			EnemyUnit3 = Actor.Create(RandomHeliUnit, true, { Location = CPos.New(151,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not hpadKilled4 then
			EnemyUnit4 = Actor.Create(RandomHeliUnit, true, { Location = CPos.New(151,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AllieHeliDelayTimemin + AllieHeliDelay, AllieHeliDelayTimemax + AllieHeliDelay)), function()
			AllieHeliIncome()
		end)
	end)
end
SovietHeliIncome = function()
	if not SovietPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomHeliUnit1 = Utils.Random(SovietHeliUnit)
		if RandomHeliUnit1 == "yak" then SovietHeliDelayTimemax = 18
		elseif RandomHeliUnit1 == "mig" then SovietHeliDelayTimemax = 20 end
		if not afldKilled0 then
			EnemyUnit0 = Actor.Create(RandomHeliUnit1, true, { Location = CPos.New(151,11) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not afldKilled1 then
			EnemyUnit1 = Actor.Create(RandomHeliUnit1, true, { Location = CPos.New(151,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not afldKilled2 then
			EnemyUnit2 = Actor.Create(RandomHeliUnit1, true, { Location = CPos.New(151,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not afldKilled3 then
			EnemyUnit3 = Actor.Create(RandomHeliUnit1, true, { Location = CPos.New(151,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not afldKilled4 then
			EnemyUnit4 = Actor.Create(RandomHeliUnit1, true, { Location = CPos.New(151,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(SovietHeliDelayTimemin + SovietHeliDelay, SovietHeliDelayTimemax + SovietHeliDelay)), function()
			SovietHeliIncome()
		end)
	end)
end
GdiHeliIncome = function()
	if not GdiPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomHeliUnit2 = Utils.Random(GdiHeliUnit)
		if RandomHeliUnit2 == "orca" then GdiHeliDelayTimemax = 20 end
		if not hpadnodKilled0 then
			EnemyUnit0 = Actor.Create(RandomHeliUnit2, true, { Location = CPos.New(151,11) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not hpadnodKilled1 then
			EnemyUnit1 = Actor.Create(RandomHeliUnit2, true, { Location = CPos.New(151,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not hpadnodKilled2 then
			EnemyUnit2 = Actor.Create(RandomHeliUnit2, true, { Location = CPos.New(151,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not hpadnodKilled3 then
			EnemyUnit3 = Actor.Create(RandomHeliUnit2, true, { Location = CPos.New(151,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not hpadnodKilled4 then
			EnemyUnit4 = Actor.Create(RandomHeliUnit2, true, { Location = CPos.New(151,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(GdiHeliDelayTimemin + GdiHeliDelay, GdiHeliDelayTimemax + GdiHeliDelay)), function()
			GdiHeliIncome()
		end)
	end)
end
NodHeliIncome = function()
	if not NodPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomHeliUnit3 = Utils.Random(NodHeliUnit)
		if RandomHeliUnit3 == "apache" then NodHeliDelayTimemax = 20 end
		if not hpadnodKilled0 then
			EnemyUnit0 = Actor.Create(RandomHeliUnit3, true, { Location = CPos.New(151,11) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not hpadnodKilled1 then
			EnemyUnit1 = Actor.Create(RandomHeliUnit3, true, { Location = CPos.New(151,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not hpadnodKilled2 then
			EnemyUnit2 = Actor.Create(RandomHeliUnit3, true, { Location = CPos.New(151,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not hpadnodKilled3 then
			EnemyUnit3 = Actor.Create(RandomHeliUnit3, true, { Location = CPos.New(151,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not hpadnodKilled4 then
			EnemyUnit4 = Actor.Create(RandomHeliUnit3, true, { Location = CPos.New(151,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(NodHeliDelayTimemin + NodHeliDelay, NodHeliDelayTimemax + NodHeliDelay)), function()
			NodHeliIncome()
		end)
	end)
end
EnemyMonsterIncome = function()
	if not MonsterPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomMonsterUnit = Utils.Random(EnemyMonsterUnit)
		
		if RandomMonsterUnit == "PVICE" then MonsterDelayTimemax = 13
		elseif RandomMonsterUnit == "zombie" then MonsterDelayTimemax = 10
		elseif RandomMonsterUnit == "IMP" then MonsterDelayTimemax = 28
		elseif RandomMonsterUnit == "REVE" then MonsterDelayTimemax = 30
		elseif RandomMonsterUnit == "BSPI" then MonsterDelayTimemax = 22
		elseif RandomMonsterUnit == "PINKY" then MonsterDelayTimemax = 35
		elseif RandomMonsterUnit == "MANC" then MonsterDelayTimemax = 45 end
		if not bioKilled0 then
			EnemyUnit0 = Actor.Create(RandomMonsterUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not bioKilled1 then
			EnemyUnit1 = Actor.Create(RandomMonsterUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not bioKilled2 then
			EnemyUnit2 = Actor.Create(RandomMonsterUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not bioKilled3 then
			EnemyUnit3 = Actor.Create(RandomMonsterUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not bioKilled4 then
			EnemyUnit4 = Actor.Create(RandomMonsterUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(MonsterDelayTimemin + MonsterDelay, MonsterDelayTimemax + MonsterDelay)), function()
			EnemyMonsterIncome()
		end)
	end)
end

EnemyAntIncome = function()
	if not AntPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomAntUnit = Utils.Random(EnemyAntUnit)
		if RandomAntUnit == "ant" then AntDelayTimemax = 11
		elseif RandomAntUnit == "scoutant" then AntDelayTimemax = 8
		elseif RandomAntUnit == "warriorant" then AntDelayTimemax = 12
		elseif RandomAntUnit == "fireant" then AntDelayTimemax = 13
		elseif RandomAntUnit == "toxicant" then AntDelayTimemax = 14
		elseif RandomAntUnit == "electricant" then AntDelayTimemax = 15
		elseif RandomAntUnit == "lavaant" then AntDelayTimemax = 23 end
		if not anthillKilled0 then
			EnemyUnit0 = Actor.Create(RandomAntUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not anthillKilled1 then
			EnemyUnit1 = Actor.Create(RandomAntUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not anthillKilled2 then
			EnemyUnit2 = Actor.Create(RandomAntUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not anthillKilled3 then
			EnemyUnit3 = Actor.Create(RandomAntUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not anthillKilled4 then
			EnemyUnit4 = Actor.Create(RandomAntUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(AntDelayTimemin + AntDelay, AntDelayTimemax + AntDelay)), function()
			EnemyAntIncome()
		end)
	end)
end

EnemyDinoIncome = function()
	if not DinoPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomDinoUnit = Utils.Random(EnemyDinoUnit)
		if RandomDinoUnit == "PARAUSAR" then DinoDelayTimemax = 15
		elseif RandomDinoUnit == "TRICERATOPS" then DinoDelayTimemax = 16
		elseif RandomDinoUnit == "STEGOSAUR" then DinoDelayTimemax = 16
		elseif RandomDinoUnit == "ALLOSAURUS" then DinoDelayTimemax = 17
		elseif RandomDinoUnit == "TYREX" then DinoDelayTimemax = 18
		elseif RandomDinoUnit == "BRACHIOSAURUS" then DinoDelayTimemax = 21
		elseif RandomDinoUnit == "GALLIMUS" then DinoDelayTimemax = 12 end
		if not bioKilled0 then
			EnemyUnit0 = Actor.Create(RandomDinoUnit, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not bioKilled1 then
			EnemyUnit1 = Actor.Create(RandomDinoUnit, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not bioKilled2 then
			EnemyUnit2 = Actor.Create(RandomDinoUnit, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not bioKilled3 then
			EnemyUnit3 = Actor.Create(RandomDinoUnit, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not bioKilled4 then
			EnemyUnit4 = Actor.Create(RandomDinoUnit, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(DinoDelayTimemin + DinoDelay, DinoDelayTimemax + DinoDelay)), function()
			EnemyDinoIncome()
		end)
	end)
end

EnemyCustomHeliIncome = function()
	if not MonsterPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomCustomUnit = Utils.Random(EnemyCustomHeliUnit)
		if RandomCustomUnit == "lynx" then CustomHeliDelayTimemax = 19
		elseif RandomCustomUnit == "cobra" then CustomHeliDelayTimemax = 20
		elseif RandomCustomUnit == "huey" then CustomHeliDelayTimemax = 21
		elseif RandomCustomUnit == "UFO.Beamer" then CustomHeliDelayTimemax = 20
		elseif RandomCustomUnit == "UFO.LASER" then CustomHeliDelayTimemax = 25
		elseif RandomCustomUnit == "UFO" then CustomHeliDelayTimemax = 27 end
		if not bioKilled0 then
			EnemyUnit0 = Actor.Create(RandomCustomUnit, true, { Location = CPos.New(151,11) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not bioKilled1 then
			EnemyUnit1 = Actor.Create(RandomCustomUnit, true, { Location = CPos.New(151,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not bioKilled2 then
			EnemyUnit2 = Actor.Create(RandomCustomUnit, true, { Location = CPos.New(151,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not bioKilled3 then
			EnemyUnit3 = Actor.Create(RandomCustomUnit, true, { Location = CPos.New(151,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not bioKilled4 then
			EnemyUnit4 = Actor.Create(RandomCustomUnit, true, { Location = CPos.New(151,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(CustomHeliDelayTimemin + CustomHeliDelay, CustomHeliDelayTimemax + CustomHeliDelay)), function()
			EnemyCustomHeliIncome()
		end)
	end)
end

EnemyCustomHeavyIncome = function()
	if not MonsterPeaceTime then
		Attackpath0 = { CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath1 = { CPos.New(8,39) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath2 = { CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath3 = { CPos.New(8,65) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		Attackpath4 = { CPos.New(8,91) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,22) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)), CPos.New(8,50) + CVec.New(Utils.RandomInteger(-3, 3), Utils.RandomInteger(-3, 3)) }
		RandomPosition = Utils.RandomInteger(0, 13)
		RandomCustomUnit1 = Utils.Random(EnemyCustomHeavyUnit)
		if RandomCustomUnit1 == "godzilla" then CustomHeavyDelayTimemax = 35
		elseif RandomCustomUnit1 == "kingkong" then CustomHeavyDelayTimemax = 37
		elseif RandomCustomUnit1 == "superman" then CustomHeavyDelayTimemax = 40 end
		if not bioKilled0 then
			EnemyUnit0 = Actor.Create(RandomCustomUnit1, true, { Location = CPos.New(150,1) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy0 = { EnemyUnit0 }
			GroupPatrol(Enemy0, Attackpath0, DateTime.Seconds(1))
		end
		if not bioKilled1 then
			EnemyUnit1 = Actor.Create(RandomCustomUnit1, true, { Location = CPos.New(150,30) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy1 = { EnemyUnit1 }
			GroupPatrol(Enemy1, Attackpath1, DateTime.Seconds(1))
		end
		if not bioKilled2 then
			EnemyUnit2 = Actor.Create(RandomCustomUnit1, true, { Location = CPos.New(150,44) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy2 = { EnemyUnit2 }
			GroupPatrol(Enemy2, Attackpath2, DateTime.Seconds(1))
		end
		if not bioKilled3 then
			EnemyUnit3 = Actor.Create(RandomCustomUnit1, true, { Location = CPos.New(150,58) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy3 = { EnemyUnit3 }
			GroupPatrol(Enemy3, Attackpath3, DateTime.Seconds(1))
		end
		if not bioKilled4 then
			EnemyUnit4 = Actor.Create(RandomCustomUnit1, true, { Location = CPos.New(150,87) + CVec.New(0, RandomPosition), Owner = Enemys })
			Enemy4 = { EnemyUnit4 }
			GroupPatrol(Enemy4, Attackpath4, DateTime.Seconds(1))
		end
	end
	Trigger.AfterDelay(1, function()
		Trigger.AfterDelay(DateTime.Seconds(Utils.RandomInteger(CustomHeavyDelayTimemin + CustomHeavyDelay, CustomHeavyDelayTimemax + CustomHeavyDelay)), function()
			EnemyCustomHeavyIncome()
		end)
	end)
end